## lime 0.3.0

=== DESCRIPTION ===
Package: lime
Type: Package
Title: Local Interpretable Model-Agnostic Explanations
Version: 0.3.0
Date: 2017-09-14
Authors@R: c(person('Thomas Lin', 'Pedersen', role = c('cre', 'aut'), email = "thomasp85@gmail.com"),
             person('Michaël', 'Benesty', role = c('aut'), email = "michael@benesty.fr"))
Maintainer: Thomas Lin Pedersen <thomasp85@gmail.com>
Description: When building complex models, it is often difficult to explain why
    the model should be trusted. While global measures such as accuracy are
    useful, they cannot be used for explaining why a model made a specific
    prediction. 'lime' (a port of the 'lime' 'Python' package) is a method for
    explaining the outcome of black box models by fitting a local model around
    the point in question an perturbations of this point. The approach is
    described in more detail in the article by Ribeiro et al. (2016) 
    <arXiv:1602.04938>.
License: MIT + file LICENSE
URL: https://github.com/thomasp85/lime
BugReports: https://github.com/thomasp85/lime/issues
Encoding: UTF-8
LazyData: true
RoxygenNote: 6.0.1
VignetteBuilder: knitr
Imports: glmnet, stats, ggplot2, tools, stringi, Matrix, stringdist,
        Rcpp, assertthat, htmlwidgets, shiny, shinythemes
Suggests: xgboost, testthat, mlr, text2vec, MASS, covr, knitr,
        rmarkdown, devtools
LinkingTo: Rcpp, RcppEigen
NeedsCompilation: yes
Packaged: 2017-09-15 12:04:03 UTC; thomas
Author: Thomas Lin Pedersen [cre, aut],
  Michaël Benesty [aut]
Repository: CRAN
Date/Publication: 2017-09-15 12:14:56 UTC

## lime 0.3.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: lime
 Type: Package
 Title: Local Interpretable Model-Agnostic Explanations
-Version: 0.3.0
-Date: 2017-09-14
+Version: 0.3.1
+Date: 2017-11-24
 Authors@R: c(person('Thomas Lin', 'Pedersen', role = c('cre', 'aut'), email = "thomasp85@gmail.com"),
              person('Michaël', 'Benesty', role = c('aut'), email = "michael@benesty.fr"))
 Maintainer: Thomas Lin Pedersen <thomasp85@gmail.com>
@@ -23,12 +23,12 @@
 VignetteBuilder: knitr
 Imports: glmnet, stats, ggplot2, tools, stringi, Matrix, stringdist,
         Rcpp, assertthat, htmlwidgets, shiny, shinythemes
-Suggests: xgboost, testthat, mlr, text2vec, MASS, covr, knitr,
+Suggests: xgboost, testthat, mlr, h2o, text2vec, MASS, covr, knitr,
         rmarkdown, devtools
 LinkingTo: Rcpp, RcppEigen
 NeedsCompilation: yes
-Packaged: 2017-09-15 12:04:03 UTC; thomas
+Packaged: 2017-11-24 09:24:29 UTC; thomas
 Author: Thomas Lin Pedersen [cre, aut],
   Michaël Benesty [aut]
 Repository: CRAN
-Date/Publication: 2017-09-15 12:14:56 UTC
+Date/Publication: 2017-11-24 10:11:26 UTC

## lime 0.4.0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: lime
 Type: Package
 Title: Local Interpretable Model-Agnostic Explanations
-Version: 0.3.1
-Date: 2017-11-24
+Version: 0.4.0
+Date: 2018-03-08
 Authors@R: c(person('Thomas Lin', 'Pedersen', role = c('cre', 'aut'), email = "thomasp85@gmail.com"),
              person('Michaël', 'Benesty', role = c('aut'), email = "michael@benesty.fr"))
 Maintainer: Thomas Lin Pedersen <thomasp85@gmail.com>
@@ -19,16 +19,17 @@
 BugReports: https://github.com/thomasp85/lime/issues
 Encoding: UTF-8
 LazyData: true
-RoxygenNote: 6.0.1
+RoxygenNote: 6.0.1.9000
 VignetteBuilder: knitr
 Imports: glmnet, stats, ggplot2, tools, stringi, Matrix, stringdist,
-        Rcpp, assertthat, htmlwidgets, shiny, shinythemes
+        Rcpp, assertthat, htmlwidgets, shiny, shinythemes, magick,
+        methods, grDevices, gower
 Suggests: xgboost, testthat, mlr, h2o, text2vec, MASS, covr, knitr,
-        rmarkdown, devtools
+        rmarkdown, devtools, keras
 LinkingTo: Rcpp, RcppEigen
 NeedsCompilation: yes
-Packaged: 2017-11-24 09:24:29 UTC; thomas
+Packaged: 2018-03-08 22:29:41 UTC; thomas
 Author: Thomas Lin Pedersen [cre, aut],
   Michaël Benesty [aut]
 Repository: CRAN
-Date/Publication: 2017-11-24 10:11:26 UTC
+Date/Publication: 2018-03-08 22:50:58 UTC

## lime 0.4.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: lime
 Type: Package
 Title: Local Interpretable Model-Agnostic Explanations
-Version: 0.4.0
-Date: 2018-03-08
+Version: 0.4.1
+Date: 2018-11-21
 Authors@R: c(person('Thomas Lin', 'Pedersen', role = c('cre', 'aut'), email = "thomasp85@gmail.com"),
              person('Michaël', 'Benesty', role = c('aut'), email = "michael@benesty.fr"))
 Maintainer: Thomas Lin Pedersen <thomasp85@gmail.com>
@@ -19,17 +19,17 @@
 BugReports: https://github.com/thomasp85/lime/issues
 Encoding: UTF-8
 LazyData: true
-RoxygenNote: 6.0.1.9000
+RoxygenNote: 6.1.1
 VignetteBuilder: knitr
-Imports: glmnet, stats, ggplot2, tools, stringi, Matrix, stringdist,
-        Rcpp, assertthat, htmlwidgets, shiny, shinythemes, magick,
-        methods, grDevices, gower
+Imports: glmnet, stats, ggplot2, tools, stringi, Matrix, Rcpp,
+        assertthat, htmlwidgets, shiny, shinythemes, methods,
+        grDevices, gower
 Suggests: xgboost, testthat, mlr, h2o, text2vec, MASS, covr, knitr,
-        rmarkdown, devtools, keras
+        rmarkdown, devtools, magick, keras, ranger
 LinkingTo: Rcpp, RcppEigen
 NeedsCompilation: yes
-Packaged: 2018-03-08 22:29:41 UTC; thomas
+Packaged: 2018-11-21 12:20:40 UTC; thomas
 Author: Thomas Lin Pedersen [cre, aut],
   Michaël Benesty [aut]
 Repository: CRAN
-Date/Publication: 2018-03-08 22:50:58 UTC
+Date/Publication: 2018-11-21 12:50:02 UTC

## lime 0.5.0

=== DESCRIPTION ===
Package: lime
Type: Package
Title: Local Interpretable Model-Agnostic Explanations
Version: 0.5.0
Date: 2019-06-13
Authors@R: 
    c(person(given = "Thomas Lin",
             family = "Pedersen",
             role = c("cre", "aut"),
             email = "thomasp85@gmail.com",
             comment = c(ORCID = "0000-0002-5147-4711")),
      person(given = 'Michaël', 
             family = 'Benesty', 
             role = c('aut'), 
             email = "michael@benesty.fr"))
Maintainer: Thomas Lin Pedersen <thomasp85@gmail.com>
Description: When building complex models, it is often difficult to explain why
    the model should be trusted. While global measures such as accuracy are
    useful, they cannot be used for explaining why a model made a specific
    prediction. 'lime' (a port of the 'lime' 'Python' package) is a method for
    explaining the outcome of black box models by fitting a local model around
    the point in question an perturbations of this point. The approach is
    described in more detail in the article by Ribeiro et al. (2016) 
    <arXiv:1602.04938>.
License: MIT + file LICENSE
URL: https://lime.data-imaginist.com
BugReports: https://github.com/thomasp85/lime/issues
Encoding: UTF-8
LazyData: true
RoxygenNote: 6.1.1
VignetteBuilder: knitr
Imports: glmnet, stats, ggplot2, tools, stringi, Matrix, Rcpp,
        assertthat, htmlwidgets, shiny, shinythemes, methods,
        grDevices, gower
Suggests: xgboost, testthat, mlr, h2o, text2vec, MASS, covr, knitr,
        rmarkdown, sessioninfo, magick, keras, ranger
LinkingTo: Rcpp, RcppEigen
NeedsCompilation: yes
Packaged: 2019-06-24 10:16:24 UTC; thomas
Author: Thomas Lin Pedersen [cre, aut]
    (<https://orcid.org/0000-0002-5147-4711>),
  Michaël Benesty [aut]
Repository: CRAN
Date/Publication: 2019-06-24 10:50:03 UTC

## lime 0.5.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Package: lime
 Type: Package
 Title: Local Interpretable Model-Agnostic Explanations
-Version: 0.5.0
-Date: 2019-06-13
+Version: 0.5.1
 Authors@R: 
     c(person(given = "Thomas Lin",
              family = "Pedersen",
@@ -23,7 +22,7 @@
     described in more detail in the article by Ribeiro et al. (2016) 
     <arXiv:1602.04938>.
 License: MIT + file LICENSE
-URL: https://lime.data-imaginist.com
+URL: https://lime.data-imaginist.com, https://github.com/thomasp85/lime
 BugReports: https://github.com/thomasp85/lime/issues
 Encoding: UTF-8
 LazyData: true
@@ -36,9 +35,9 @@
         rmarkdown, sessioninfo, magick, keras, ranger
 LinkingTo: Rcpp, RcppEigen
 NeedsCompilation: yes
-Packaged: 2019-06-24 10:16:24 UTC; thomas
+Packaged: 2019-11-12 07:34:00 UTC; thomas
 Author: Thomas Lin Pedersen [cre, aut]
     (<https://orcid.org/0000-0002-5147-4711>),
   Michaël Benesty [aut]
 Repository: CRAN
-Date/Publication: 2019-06-24 10:50:03 UTC
+Date/Publication: 2019-11-12 08:20:02 UTC

## lime 0.5.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: lime
 Type: Package
 Title: Local Interpretable Model-Agnostic Explanations
-Version: 0.5.1
+Version: 0.5.2
 Authors@R: 
     c(person(given = "Thomas Lin",
              family = "Pedersen",
@@ -26,18 +26,18 @@
 BugReports: https://github.com/thomasp85/lime/issues
 Encoding: UTF-8
 LazyData: true
-RoxygenNote: 6.1.1
+RoxygenNote: 7.1.1
 VignetteBuilder: knitr
 Imports: glmnet, stats, ggplot2, tools, stringi, Matrix, Rcpp,
-        assertthat, htmlwidgets, shiny, shinythemes, methods,
-        grDevices, gower
+        assertthat, methods, grDevices, gower
 Suggests: xgboost, testthat, mlr, h2o, text2vec, MASS, covr, knitr,
-        rmarkdown, sessioninfo, magick, keras, ranger
+        rmarkdown, sessioninfo, magick, keras, htmlwidgets, shiny,
+        shinythemes, ranger
 LinkingTo: Rcpp, RcppEigen
 NeedsCompilation: yes
-Packaged: 2019-11-12 07:34:00 UTC; thomas
+Packaged: 2021-02-24 11:20:57 UTC; thomas
 Author: Thomas Lin Pedersen [cre, aut]
     (<https://orcid.org/0000-0002-5147-4711>),
   Michaël Benesty [aut]
 Repository: CRAN
-Date/Publication: 2019-11-12 08:20:02 UTC
+Date/Publication: 2021-02-24 12:00:02 UTC

## lime 0.5.3

=== DESCRIPTION ===
--- 
+++ 
@@ -1,18 +1,23 @@
 Package: lime
 Type: Package
 Title: Local Interpretable Model-Agnostic Explanations
-Version: 0.5.2
+Version: 0.5.3
 Authors@R: 
-    c(person(given = "Thomas Lin",
+    c(person(given = "Emil",
+             family = "Hvitfeldt",
+             role = c("aut", "cre"),
+             email = "emilhhvitfeldt@gmail.com",
+             comment = c(ORCID = "0000-0002-0679-1945")),
+      person(given = "Thomas Lin",
              family = "Pedersen",
-             role = c("cre", "aut"),
+             role = c("aut"),
              email = "thomasp85@gmail.com",
              comment = c(ORCID = "0000-0002-5147-4711")),
       person(given = 'Michaël', 
              family = 'Benesty', 
              role = c('aut'), 
              email = "michael@benesty.fr"))
-Maintainer: Thomas Lin Pedersen <thomasp85@gmail.com>
+Maintainer: Emil Hvitfeldt <emilhhvitfeldt@gmail.com>
 Description: When building complex models, it is often difficult to explain why
     the model should be trusted. While global measures such as accuracy are
     useful, they cannot be used for explaining why a model made a specific
@@ -26,7 +31,7 @@
 BugReports: https://github.com/thomasp85/lime/issues
 Encoding: UTF-8
 LazyData: true
-RoxygenNote: 7.1.1
+RoxygenNote: 7.2.1
 VignetteBuilder: knitr
 Imports: glmnet, stats, ggplot2, tools, stringi, Matrix, Rcpp,
         assertthat, methods, grDevices, gower
@@ -35,9 +40,9 @@
         shinythemes, ranger
 LinkingTo: Rcpp, RcppEigen
 NeedsCompilation: yes
-Packaged: 2021-02-24 11:20:57 UTC; thomas
-Author: Thomas Lin Pedersen [cre, aut]
-    (<https://orcid.org/0000-0002-5147-4711>),
+Packaged: 2022-08-18 12:46:04 UTC; thomas
+Author: Emil Hvitfeldt [aut, cre] (<https://orcid.org/0000-0002-0679-1945>),
+  Thomas Lin Pedersen [aut] (<https://orcid.org/0000-0002-5147-4711>),
   Michaël Benesty [aut]
 Repository: CRAN
-Date/Publication: 2021-02-24 12:00:02 UTC
+Date/Publication: 2022-08-19 08:50:06 UTC

## lime 0.5.4

=== DESCRIPTION ===
Type: Package
Package: lime
Title: Local Interpretable Model-Agnostic Explanations
Version: 0.5.4
Authors@R: c(
    person("Emil", "Hvitfeldt", , "emil.hvitfeldt@posit.co", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-0679-1945")),
    person("Thomas Lin", "Pedersen", , "thomasp85@gmail.com", role = "aut",
           comment = c(ORCID = "0000-0002-5147-4711")),
    person("Michaël", "Benesty", , "michael@benesty.fr", role = "aut")
  )
Maintainer: Emil Hvitfeldt <emil.hvitfeldt@posit.co>
Description: When building complex models, it is often difficult to
    explain why the model should be trusted. While global measures such as
    accuracy are useful, they cannot be used for explaining why a model
    made a specific prediction. 'lime' (a port of the 'lime' 'Python'
    package) is a method for explaining the outcome of black box models by
    fitting a local model around the point in question an perturbations of
    this point. The approach is described in more detail in the article by
    Ribeiro et al. (2016) <doi:10.48550/arXiv.1602.04938>.
License: MIT + file LICENSE
URL: https://lime.data-imaginist.com,
        https://github.com/tidymodels/lime,
        https://lime.data-imaginist.com/
BugReports: https://github.com/tidymodels/lime/issues
Depends: R (>= 4.1)
Imports: assertthat, ggplot2, glmnet, glue, gower, grDevices,
        lifecycle, Matrix, methods, Rcpp, rlang, stats, stringi, tools
Suggests: covr, h2o, htmlwidgets, keras, knitr, magick, MASS, mlr,
        ranger, rmarkdown, sessioninfo, shiny, shinythemes, testthat
        (>= 3.0.0), text2vec, xgboost
LinkingTo: Rcpp, RcppEigen
VignetteBuilder: knitr
Config/testthat/edition: 3
Config/usethis/last-upkeep: 2025-12-08
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.3.3
NeedsCompilation: yes
Packaged: 2025-12-10 00:24:27 UTC; emilhvitfeldt
Author: Emil Hvitfeldt [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-0679-1945>),
  Thomas Lin Pedersen [aut] (ORCID:
    <https://orcid.org/0000-0002-5147-4711>),
  Michaël Benesty [aut]
Repository: CRAN
Date/Publication: 2025-12-11 16:00:02 UTC

## lime 5.0.37+dfsg

=== CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2010-2019  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################
include(GNUInstallDirs)
include(CheckSymbolExists)
include(CheckLibraryExists)
include(CMakePushCheckState)
include(CMakePackageConfigHelpers)

cmake_minimum_required(VERSION 3.1)

option(ENABLE_SHARED "Build shared library." YES)
option(ENABLE_STATIC "Build static library." YES)
option(ENABLE_STRICT "Build with strict compile options." YES)
option(ENABLE_CURVE25519 "Enable support of Curve 25519." YES)
option(ENABLE_CURVE448 "Enable support of Curve 448(goldilock)." YES)
option(ENABLE_UNIT_TESTS "Enable compilation of unit tests." YES)
option(ENABLE_DOC "Enable API documentation generation." NO)
option(ENABLE_PROFILING "Enable profiling, GCC only" NO)
option(ENABLE_C_INTERFACE "Enable support of C89 foreign function interface" NO)
option(ENABLE_JNI "Enable support of Java foreign function interface" NO)
option(ENABLE_PACKAGE_SOURCE "Create 'package_source' target for source archive making (CMake >= 3.11)" OFF)

set (LANGUAGES_LIST CXX)
if (ENABLE_C_INTERFACE)
	set (LANGUAGES_LIST ${LANGUAGES_LIST} C)
endif()
if (ENABLE_JNI)
	set (LANGUAGES_LIST ${LANGUAGES_LIST} Java)
endif()

project(lime VERSION 5.0.0 LANGUAGES ${LANGUAGES_LIST})

set(LIME_SO_VERSION "0")
set(LIME_VERSION ${PROJECT_VERSION})


list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

if(NOT CPACK_GENERATOR AND NOT CMAKE_INSTALL_RPATH AND CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
	message(STATUS "Setting install rpath to ${CMAKE_INSTALL_RPATH}")
endif()

find_package(bctoolbox 0.5.1 REQUIRED OPTIONAL_COMPONENTS tester)

find_package(Soci REQUIRED)

include_directories(
	include/
	src/
	${CMAKE_CURRENT_BINARY_DIR}
)
if(MSVC)
	include_directories(${MSVC_INCLUDE_DIR})
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/config.h PROPERTIES GENERATED ON)

set(LIME_CPPFLAGS ${BCTOOLBOX_CPPFLAGS})
if(LIME_CPPFLAGS)
	list(REMOVE_DUPLICATES LIME_CPPFLAGS)
	add_definitions(${LIME_CPPFLAGS})
endif()
add_definitions("-DLIME_EXPORTS")

set(STRICT_OPTIONS_C)
set(STRICT_OPTIONS_CPP )
set(STRICT_OPTIONS_CXX )
set(STRICT_OPTIONS_OBJC )

if(ENABLE_JNI)
	set(CMAKE_CXX_STANDARD 14)
else()
	set(CMAKE_CXX_STANDARD 11)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_STANDARD 99)

if(MSVC)
	if(ENABLE_STRICT)
		list(APPEND STRICT_OPTIONS_CPP "/WX")
	endif()
	# avoid conflicts with std::min and std::max
	add_definitions("-DNOMINMAX")
else()
	if (ENABLE_PROFILING)
		list(APPEND STRICT_OPTIONS_CXX "-g -pg")
	endif()
        #list(APPEND STRICT_OPTIONS_CPP "-Wall" "-Wuninitialized" "-Wno-error=deprecated-declarations") # turn off deprecated-declaration warning to avoid being flooded by soci.h
	list(APPEND STRICT_OPTIONS_CPP "-Wall" "-Wuninitialized" "-Wno-deprecated-declarations" "-Wno-missing-field-initializers")

	if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
		list(APPEND STRICT_OPTIONS_CPP "-Qunused-arguments" "-Wno-array-bounds")
	endif()
	if(APPLE)
		list(APPEND STRICT_OPTIONS_CPP "-Wno-error=unknown-warning-option" "-Qunused-arguments" "-Wno-tautological-compare" "-Wno-unused-function" "-Wno-array-bounds")
	endif()
	if(ENABLE_STRICT)
		list(APPEND STRICT_OPTIONS_CPP "-Werror" "-Wextra" "-Wno-unused-parameter" "-fno-strict-aliasing")
	endif()
endif()
if(STRICT_OPTIONS_CPP)
	list(REMOVE_DUPLICATES STRICT_OPTIONS_CPP)
endif()

set(EXPORT_TARGETS_NAME "lime")

if (ENABLE_CURVE25519)
	add_definitions("-DEC25519_ENABLED")
	message(STATUS "Support Curve 25519")
endif()

if (ENABLE_CURVE448)
	add_definitions("-DEC448_ENABLED")
	message(STATUS "Support Curve 448")
endif()

if(ENABLE_C_INTERFACE)
	add_definitions("-DFFI_ENABLED")
	message(STATUS "Provide C89 interface")
endif()

if(ENABLE_JNI)
	message(STATUS "Provide JNI interface")
	if (NOT ANDROID)
		find_package(JNI REQUIRED)

		if (JNI_FOUND)
			message (STATUS "JNI_INCLUDE_DIRS=${JNI_INCLUDE_DIRS}")
			message (STATUS "JNI_LIBRARIES=${JNI_LIBRARIES}")
		endif()
	endif()
endif()

add_subdirectory(include)
add_subdirectory(src)
if(ENABLE_UNIT_TESTS)
        enable_testing()
	add_subdirectory(tester)
endif()

set(ConfigPackageLocation "${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/cmake")

export(EXPORT ${EXPORT_TARGETS_NAME}Targets
	FILE "${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGETS_NAME}Targets.cmake"
)

configure_package_config_file(cmake/LimeConfig.cmake.in
	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGETS_NAME}Config.cmake"
  	INSTALL_DESTINATION ${ConfigPackageLocation}
	NO_SET_AND_CHECK_MACRO
)

install(EXPORT ${EXPORT_TARGETS_NAME}Targets
	FILE ${EXPORT_TARGETS_NAME}Targets.cmake
	DESTINATION ${ConfigPackageLocation}
)
install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGETS_NAME}Config.cmake"
	DESTINATION ${ConfigPackageLocation}
)

if(ENABLE_DOC)
	# Doxygen
	find_package(Doxygen)
	if (DOXYGEN_FOUND)
		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
		add_custom_target(doc ALL
			${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			COMMENT "Generating API documentation with Doxygen" VERBATIM)
		install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/doc/html/"
			DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/lime-${LIME_VERSION}")
	endif()
endif()

if (ENABLE_PACKAGE_SOURCE)
	add_subdirectory(build)
endif()

=== debian/changelog ===
lime (5.0.37+dfsg-5) unstable; urgency=medium

  * Rebuild for libsoci ABI bump, see Bug#1021125

 -- Bernhard Schmidt <berni@debian.org>  Sun, 16 Oct 2022 11:38:33 +0200

lime (5.0.37+dfsg-4) unstable; urgency=medium

  * Release to unstable.
  * d/gbp.conf for debian/unstable branch

 -- Bernhard Schmidt <berni@debian.org>  Mon, 12 Sep 2022 20:27:46 +0200

lime (5.0.37+dfsg-3) experimental; urgency=medium

  * Move default-jdk to Build-Depends as well

 -- Bernhard Schmidt <berni@debian.org>  Thu, 18 Aug 2022 10:22:20 +0200

lime (5.0.37+dfsg-2) experimental; urgency=medium

  * Move javahelper from Build-Depends-Indeps to Build-Depends
    (Closes: #1017585)

 -- Bernhard Schmidt <berni@debian.org>  Thu, 18 Aug 2022 09:06:46 +0200

lime (5.0.37+dfsg-1) experimental; urgency=medium

  * Initial release.
  * Features DH key exchange with Curve448-Goldilocks and Curve25519
  * JNI-based Java wrapper (liblime-java)
  * Doxygen documentation (liblime-doc)
  * Static libraries are not shipped; file a bug if you need them.

 -- Dennis Filder <d.filder@web.de>  Wed, 08 Jun 2022 23:36:03 +0200

=== debian/control ===
Source: lime
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Bernhard Schmidt <berni@debian.org>
Build-Depends: cmake,
 debhelper-compat (= 13),
 default-jdk (>= 2:1.7) <!nojava>,
 javahelper <!nojava>,
Build-Depends-Arch:
 libbctoolbox-dev (>= 5.0.37~),
 libsoci-dev,
 libsqlite3-dev,
 libboost1.74-dev,
Build-Depends-Indep:
 doxygen <!nodoc>,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Section: libs
Homepage: http://www.linphone.org/technical-corner/lime
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/lime
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/lime.git

Package: liblime-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblime0 (= ${binary:Version}), ${misc:Depends}
Description: End-to-end encryption library featuring ECC and PFS
 LIME is an end-to-end encryption library for one-to-one and group
 instant messaging, allowing users to exchange messages privately and
 asynchronously. It uses Curve448-Goldilocks for key agreement and
 employs a double ratchet algorithm for perfect forward secrecy.
 .
 LIME is composed of a portable client library coupled with a public
 key server developed by Belledonne Communications to allow end-to-end
 encryption for messaging, without having to exchange cryptographic
 keys simultaneously.
 .
 The library exposes a C, C++ and Java API for easy integration in
 mobile and desktop environments.
 .
 This package contains everything needed to build software written
 against LIME.

Package: liblime0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: End-to-end encryption library featuring ECC and PFS
 LIME is an end-to-end encryption library for one-to-one and group
 instant messaging, allowing users to exchange messages privately and
 asynchronously. It uses Curve448-Goldilocks for key agreement and
 employs a double ratchet algorithm for perfect forward secrecy.
 .
 LIME is composed of a portable client library coupled with a public
 key server developed by Belledonne Communications to allow end-to-end
 encryption for messaging, without having to exchange cryptographic
 keys simultaneously.
 .
 The library exposes a C, C++ and Java API for easy integration in
 mobile and desktop environments.
 .
 This package contains the run-time shared library.

Package: liblime-doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends}
Description: End-to-end encryption library featuring ECC and PFS
 LIME is an end-to-end encryption library for one-to-one and group
 instant messaging, allowing users to exchange messages privately and
 asynchronously. It uses Curve448-Goldilocks for key agreement and
 employs a double ratchet algorithm for perfect forward secrecy.
 .
 LIME is composed of a portable client library coupled with a public
 key server developed by Belledonne Communications to allow end-to-end
 encryption for messaging, without having to exchange cryptographic
 keys simultaneously.
 .
 The library exposes a C, C++ and Java API for easy integration in
 mobile and desktop environments.
 .
 This package contains the developer documentation.

Package: liblime-java
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nojava>
Depends: liblime0 (>= ${binary:Version}), ${misc:Depends}
Description: End-to-end encryption library featuring ECC and PFS
 LIME is an end-to-end encryption library for one-to-one and group
 instant messaging, allowing users to exchange messages privately and
 asynchronously. It uses Curve448-Goldilocks for key agreement and
 employs a double ratchet algorithm for perfect forward secrecy.
 .
 LIME is composed of a portable client library coupled with a public
 key server developed by Belledonne Communications to allow end-to-end
 encryption for messaging, without having to exchange cryptographic
 keys simultaneously.
 .
 The library exposes a C, C++ and Java API for easy integration in
 mobile and desktop environments.
 .
 This package contains the Java wrapper.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM

DEB_REQUESTED_PACKAGES := $(shell dh_listpackages)
when-in-build-profile     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-not-in-build-profile = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-building-package     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))
when-not-building-package = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq (x,$(call when-building-package,liblime-java,x))
export JAVA_HOME=/usr/lib/jvm/default-java
export CLASSPATH=/usr/share/java/csv.jar:/usr/share/java/debug-disable.jar:/usr/share/java/itext.jar
dh_modules ?= --with
dh_modules += javahelper
endif

%:
	dh $@ $(dh_modules)

# I suspect this might be necessary to minimize the ABI difference
# when disabling JNI (otherwise C++11 is used which should generate
# different symbols thus throwing off dh_gensymbols)
options += -DCMAKE_CXX_STANDARD=14
options += -DDEB_VERSION_UPSTREAM=$${DEB_VERSION_UPSTREAM%+dfsg*}
options += -DCMAKE_SKIP_RPATH=ON # with debhelper 14 this will be the default
options += -DENABLE_STATIC=NO
options += -DENABLE_UNIT_TESTS=NO # would need: libbellesip-dev

features += -DENABLE_SHARED=$(call when-building-package,liblime0,YES,NO)
features += -DENABLE_DOC=$(call when-building-package,liblime-doc,YES,NO) # doxygen
features += -DENABLE_CURVE448=YES # libdecaf-dev
features += -DENABLE_CURVE25519=YES # libbctoolbox-dev
features += -DENABLE_JNI=YES
features += -DENABLE_C_INTERFACE=YES
features += -DENABLE_LIMEJAR=$(call when-building-package,liblime-java,YES,NO) # default-jdk, javahelper

override_dh_auto_configure:
	dh_auto_configure -- \
	 ${options} \
	 ${features}

override_dh_auto_build-arch:
	dh_auto_build -- lime
	mkdir -p obj-$(DEB_HOST_MULTIARCH)/doc/html

override_dh_auto_build-indep:
	dh_auto_build -- \
		$(call when-in-build-profile,nojava,,Lime) \
		$(call when-in-build-profile,nodoc,,doc)

## lime 5.1.64+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -47,7 +47,7 @@
 	set (LANGUAGES_LIST ${LANGUAGES_LIST} Java)
 endif()
 
-project(lime VERSION 5.0.0 LANGUAGES ${LANGUAGES_LIST})
+project(lime VERSION 5.1.0 LANGUAGES ${LANGUAGES_LIST})
 
 set(LIME_SO_VERSION "0")
 set(LIME_VERSION ${PROJECT_VERSION})

=== src/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2017  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(LIME_PRIVATE_HEADER_FILES
	lime_settings.hpp
	lime_defines.hpp
	lime_keys.hpp
	lime_impl.hpp
	lime_x3dh_protocol.hpp
	lime_localStorage.hpp
	lime_double_ratchet.hpp
	lime_double_ratchet_protocol.hpp
	lime_lime.hpp
	lime_crypto_primitives.hpp
	lime_log.hpp
)
set(LIME_SOURCE_FILES_CXX
	lime.cpp
	lime_crypto_primitives.cpp
	lime_x3dh.cpp
	lime_x3dh_protocol.cpp
	lime_localStorage.cpp
	lime_double_ratchet.cpp
	lime_double_ratchet_protocol.cpp
	lime_manager.cpp
)

if (ENABLE_C_INTERFACE)
	set(LIME_SOURCE_FILES_CXX ${LIME_SOURCE_FILES_CXX} lime_ffi.cpp)
endif()

if (ENABLE_JNI)
	set(LIME_SOURCE_FILES_CXX ${LIME_SOURCE_FILES_CXX} lime_jni.cpp)
	add_subdirectory(java)
endif()

bc_apply_compile_flags(LIME_SOURCE_FILES_CXX STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)

if(ENABLE_STATIC)
	add_library(lime-static STATIC ${LIME_PRIVATE_HEADER_FILES} ${LIME_SOURCE_FILES_CXX})
	set_target_properties(lime-static PROPERTIES OUTPUT_NAME lime)
	target_include_directories(lime-static PUBLIC ${SOCI_INCLUDE_DIRS} ${SOCI_INCLUDE_DIRS}/soci ${JNI_INCLUDE_DIRS})
	target_link_libraries(lime-static INTERFACE bctoolbox ${SOCI_sqlite3_PLUGIN}  ${SOCI_LIBRARIES} ${JNI_LIBRARIES})
	if(ENABLE_PROFILING)
		set_target_properties(lime-static PROPERTIES LINK_FLAGS "-pg")
	endif()
endif()
if(ENABLE_SHARED)
	add_library(lime SHARED ${LIME_PRIVATE_HEADER_FILES} ${LIME_HEADER_FILES} ${LIME_SOURCE_FILES_CXX})
	set_target_properties(lime PROPERTIES VERSION ${LIME_SO_VERSION})
	target_include_directories(lime PRIVATE ${SOCI_INCLUDE_DIRS} ${SOCI_INCLUDE_DIRS}/soci ${JNI_INCLUDE_DIRS} INTERFACE
		$<INSTALL_INTERFACE:include>
		$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
	)
	target_link_libraries(lime PRIVATE bctoolbox ${SOCI_LIBRARIES} ${JNI_LIBRARIES})
	if(APPLE)
		if(IOS)
			set(MIN_OS ${LINPHONE_IOS_DEPLOYMENT_TARGET})
		else()
			set(MIN_OS ${CMAKE_OSX_DEPLOYMENT_TARGET})
		endif()
		set_target_properties(lime PROPERTIES
			FRAMEWORK TRUE
			MACOSX_FRAMEWORK_IDENTIFIER com.belledonne-communications.lime
			MACOSX_FRAMEWORK_INFO_PLIST "${CMAKE_SOURCE_DIR}/build/osx/Info.plist.in"
			PUBLIC_HEADER "${LIME_HEADER_FILES}"
		)
	endif()
	if(WIN32)
		set_target_properties(lime PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
	endif()
	if(MSVC)
		if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
			install(FILES $<TARGET_PDB_FILE:lime>
				DESTINATION ${CMAKE_INSTALL_BINDIR}
				PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
			)
		endif()
	endif()
endif()

if(ENABLE_STATIC)
	install(TARGETS lime-static EXPORT ${EXPORT_TARGETS_NAME}Targets
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()
if(ENABLE_SHARED)
	install(TARGETS lime EXPORT ${EXPORT_TARGETS_NAME}Targets
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		FRAMEWORK DESTINATION Frameworks
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()

=== debian/changelog ===
lime (5.1.64+dfsg-2) unstable; urgency=medium

  * Release to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Sun, 27 Nov 2022 17:49:04 +0100

lime (5.1.64+dfsg-1) unstable; urgency=medium

  * New upstream release 5.1.64
  * Build documentation reproducibly.

 -- Dennis Filder <d.filder@web.de>  Wed, 05 Oct 2022 18:55:07 +0200

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,14 @@
  default-jdk (>= 2:1.7) <!nojava>,
  javahelper <!nojava>,
 Build-Depends-Arch:
- libbctoolbox-dev (>= 5.0.37~),
+ libbctoolbox-dev (>= 5.1.64~),
  libsoci-dev,
  libsqlite3-dev,
  libboost1.74-dev,
 Build-Depends-Indep:
  doxygen <!nodoc>,
-Standards-Version: 4.6.0
+ libregexp-assemble-perl <!nodoc>,
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Section: libs
 Homepage: http://www.linphone.org/technical-corner/lime

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 #export DH_VERBOSE = 1
 
 # see FEATURE AREAS in dpkg-buildflags(1)
+include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 export DEB_VERSION_UPSTREAM
 
@@ -47,9 +48,21 @@
 
 override_dh_auto_build-arch:
 	dh_auto_build -- lime
-	mkdir -p obj-$(DEB_HOST_MULTIARCH)/doc/html
+	mkdir -p obj-$(DEB_HOST_GNU_TYPE)/doc/html
 
+export CURDIR
 override_dh_auto_build-indep:
 	dh_auto_build -- \
 		$(call when-in-build-profile,nojava,,Lime) \
 		$(call when-in-build-profile,nodoc,,doc)
+# Doxygen puts the build path into some files with AFAIK no Off knob.
+# Edit it out manually, but sometimes $CURDIR contains RE-metacharacters,
+# so escape those first.
+
+# from tests.reproducible-builds.org
+#export CURDIR = /build/2/lime-5.0.37+dfsg/2nd
+#all:
+ifeq (x,$(call when-building-package,liblime-doc,x))
+	find obj-$(DEB_HOST_GNU_TYPE)/doc/html -type f -print0 | xargs -0 \
+		sed -z -i -E -e "s@$$(perl -MRegexp::Assemble -e 'print substr(Regexp::Assemble->new->add(quotemeta($$ENV{CURDIR})), 4, -1)')/@@g"
+endif

## lime 5.2.0%2Bdfsg

=== build/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2010-2019  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

cmake_minimum_required(VERSION 3.11) # we need CMake 3.11 for defining 'package_source' target as custom target

if(NOT CPACK_PACKAGE_NAME)
	set(CPACK_PACKAGE_NAME "lime")
endif()

set(CPACK_SOURCE_IGNORE_FILES
	"${CMAKE_BINARY_DIR}"
	"^${PROJECT_SOURCE_DIR}/.git*"
)

bc_make_package_source_target()
